ver=${1}
file="in_ffsox-${ver}.nsi"
rm -f ${file}
touch ${file}
echo "; http://nsis.sourceforge.net/Winamp_Plugin_Installer_Scripts" >> ${file}
echo ";" >> ${file}
echo "; This script generates an installer for a Winamp 2.x / 5.x plug-in." >> ${file}
echo ";" >> ${file}
echo "; The installer will automatically close Winamp if it's running and then if" >> ${file}
echo "; successful, ask the user whether or not they would like to run Winamp with" >> ${file}
echo "; the newly installed plug-in." >> ${file}
echo ";" >> ${file}
echo "; This is a single section installer but is easily altered for multiple" >> ${file}
echo "; sections and is based of the original Winamp installer script but tweaked" >> ${file}
echo "; to be easier to use i think :o)" >> ${file}
echo " " >> ${file}
echo ";--------------------------------" >> ${file}
echo " " >> ${file}
echo "; Header Files" >> ${file}
echo "; not used in this case but handy when scaling up to multiple sections" >> ${file}
echo "; !include \"Sections.nsh\"" >> ${file}
echo " " >> ${file}
echo "; common defines for a generic DrO installer :o)" >> ${file}
echo "!define VERSION \"${ver}\"" >> ${file}
echo "!define ALT_VER \"${ver}\"" >> ${file}
echo "!define PLUG \"FFSoX Player\"" >> ${file}
echo "!define PLUG_ALT \"in_ffsox\"" >> ${file}
echo "!define PLUG_FILE \"in_ffsox\"" >> ${file}
echo " " >> ${file}
echo "; use lzma compression" >> ${file}
echo "SetCompressor lzma" >> ${file}
echo " " >> ${file}
echo "; The name of the installer based on the filename and version" >> ${file}
echo "Name \"\${PLUG} v\${VERSION}\"" >> ${file}
echo " " >> ${file}
echo "; The file to write based on the filename and version" >> ${file}
echo ";OutFile \"\${PLUG_ALT}_v\${ALT_VER}.exe\"" >> ${file}
echo "OutFile \"..\\rel\\${ver}\\\${PLUG_ALT}-\${ALT_VER}.exe\"" >> ${file}
echo "; you could alter it to output you plugin installers into a common location" >> ${file}
echo "; to make it easier to maintain them" >> ${file}
echo "; OutFile \"../_Installers/\${PLUG_ALT}_v\${ALT_VER}.exe\"" >> ${file}
echo " " >> ${file}
echo "; The default installation directory" >> ${file}
echo "InstallDir \$PROGRAMFILES\\Winamp" >> ${file}
echo "InstProgressFlags smooth" >> ${file}
echo " " >> ${file}
echo "; detect Winamp path from uninstall string if available" >> ${file}
echo "InstallDirRegKey HKLM \\" >> ${file}
echo "          \"Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Winamp\" \\" >> ${file}
echo "          \"UninstallString\"" >> ${file}
echo " " >> ${file}
echo "; The text to prompt the user to enter a directory" >> ${file}
echo "DirText \"Please select your Winamp path below (you will be able to proceed \\" >> ${file}
echo "         when Winamp is detected):\"" >> ${file}
echo " " >> ${file}
echo "; automatically close the installer when done." >> ${file}
echo "AutoCloseWindow true" >> ${file}
echo " " >> ${file}
echo "; adds xp style support" >> ${file}
echo "XPStyle on" >> ${file}
echo " " >> ${file}
echo "; hide the \"show details\" box" >> ${file}
echo "ShowInstDetails nevershow" >> ${file}
echo " " >> ${file}
echo ";--------------------------------" >> ${file}
echo " " >> ${file}
echo ";Pages" >> ${file}
echo " " >> ${file}
echo "PageEx directory" >> ${file}
echo "Caption \" \"" >> ${file}
echo "PageExEnd" >> ${file}
echo " " >> ${file}
echo "; enable this line if you have extra sections and want to choose what's" >> ${file}
echo "; installed" >> ${file}
echo ";Page components" >> ${file}
echo " " >> ${file}
echo "Page instfiles" >> ${file}
echo " " >> ${file}
echo ";--------------------------------" >> ${file}
echo " " >> ${file}
echo "; CloseWinamp: this will in a loop send the Winamp window the WM_CLOSE" >> ${file}
echo "; message until it does not find a valid Winamp window" >> ${file}
echo "; (should really protect against Winamp failing to exit!)" >> ${file}
echo ";" >> ${file}
echo "Function CloseWinamp" >> ${file}
echo "  Push \$5" >> ${file}
echo "  loop:" >> ${file}
echo "    FindWindow \$5 \"Winamp v1.x\"" >> ${file}
echo "    IntCmp \$5 0 done" >> ${file}
echo "    SendMessage \$5 16 0 0" >> ${file}
echo "    Sleep 100" >> ${file}
echo "    Goto loop" >> ${file}
echo "  done:" >> ${file}
echo "  Pop \$5" >> ${file}
echo "FunctionEnd" >> ${file}
echo " " >> ${file}
echo " " >> ${file}
echo "; The stuff to install" >> ${file}
echo "Section \"\"" >> ${file}
echo "  ; attempt to close Winamp if it's running" >> ${file}
echo "  Call CloseWinamp" >> ${file}
echo "  ; add a small delay to allow any file operations to happen once Winamp" >> ${file}
echo "  ; is closed" >> ${file}
echo "  Sleep 100" >> ${file}
echo " " >> ${file}
echo "  SetOverwrite on" >> ${file}
echo "  SetOutPath \"\$INSTDIR\\Plugins\"" >> ${file}
echo "  ; File to extract" >> ${file}
echo "  File \"..\\src\\in_ffsox.dll\"" >> ${file}
echo "  SetOutPath \"\$INSTDIR\\Plugins\\in_ffsox\"" >> ${file}
echo "  File \"..\\src\\setdlgitemurl.dll\"" >> ${file}
echo "  File \"..\\tools\\bin\\libsox.dll\"" >> ${file}
echo "  File \"..\\tools\\bin\\swscale-0.dll\"" >> ${file}
echo "  File \"..\\tools\\bin\\avformat-52.dll\"" >> ${file}
echo "  File \"..\\tools\\bin\\avcodec-52.dll\"" >> ${file}
echo "  File \"..\\tools\\bin\\avcore-0.dll\"" >> ${file}
echo "  File \"..\\tools\\bin\\avutil-50.dll\"" >> ${file}
echo "  ;File /r \"doc\"" >> ${file}
#find ../doc -type f|sed -e "s,/,\\\\,g" -e "s,\(..\\\\\)\(.*\\\\\)\?\(.*\),  SetOutPath \"\$INSTDIR\\\\Plugins\\\\in_ffsox\\\\\2\",g" >> ${file}
find ../doc -type d|sed -e "s,/,\\\\,g" -e "s,\(..\\\\\)\(.*\),  SetOutPath \"\$INSTDIR\\\\Plugins\\\\in_ffsox\\\\\2\",g" >> ${file}
echo "  SetOutPath \"\$INSTDIR\\Plugins\\in_ffsox\"" >> ${file}
find ../doc -type f|sed -e "s,/,\\\\,g" -e "s,\(..\\\\\)\(.*\\\\\)\?\(.*\),  File \"/oname=\2\3\" \"\1\2\3\",g" >> ${file}
echo "  ; if you're script is in the project folder then the following file path is" >> ${file}
echo "  ; likely to apply otherwise just alter the path as needed" >> ${file}
echo "  ; File \"Release\\\${PLUG_FILE}.dll\"" >> ${file}
echo "  SetOverwrite off" >> ${file}
echo "SectionEnd" >> ${file}
echo " " >> ${file}
echo ";--------------------------------" >> ${file}
echo " " >> ${file}
echo "; Success, now prompt the user if they want to run Winamp again" >> ${file}
echo "Function .onInstSuccess" >> ${file}
echo "  MessageBox MB_YESNO \\" >> ${file}
echo "             '\${PLUG} was installed. Do you want to run Winamp now?' \\" >> ${file}
echo "	 IDNO end" >> ${file}
echo "    ExecShell open \"\$INSTDIR\\Winamp.exe\"" >> ${file}
echo "  end:" >> ${file}
echo "FunctionEnd" >> ${file}
echo " " >> ${file}
echo "; here we check to see if this a valid location ie is there a Winamp.exe" >> ${file}
echo "; in the directory?" >> ${file}
echo "Function .onVerifyInstDir" >> ${file}
echo "  ;Check for Winamp installation" >> ${file}
echo "  IfFileExists \$INSTDIR\\Winamp.exe Good" >> ${file}
echo "    Abort" >> ${file}
echo "  Good:" >> ${file}
echo "FunctionEnd" >> ${file}
