/*
 * audio_out_internal.h
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * Copyright (C) 2000-2002 Michel Lespinasse <walken@zoy.org>
 * Copyright (C) 1999-2000 Aaron Holtzman <aholtzma@ess.engr.uvic.ca>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

typedef struct raw32_instance_s {
    ao_instance_t ao;
    int sample_rate;
    int set_params;
    int flags;
    int offs;
    int size;
    int max_size;
	int32_t *int32_samples;
} raw32_instance_t;

ao_instance_t * ao_raw32_open (void);

void double2s32_2 (double * f, int32_t * s32);
void double2s32_4 (double * f, int32_t * s32);
void double2s32_5 (double * f, int32_t * s32);
int channels_multi (int flags);
void double2s32_multi (double * f, int32_t * s32, int flags);
void s32_swap (int32_t * s32, int channels);

#ifdef WORDS_BIGENDIAN
#define s32_LE(s32,channels) s32_swap (s32, channels)
#define s32_BE(s32,channels) do {} while (0)
#else
#define s32_LE(s32,channels) do {} while (0)
#define s32_BE(s32,channels) s32_swap (s32, channels)
#endif
