/*
 * liba52_stub.c
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <windows.h>
#include "liba52_stub.h"

int a52_stub_valid=0;
struct a52_stub a52;
static HINSTANCE hLibA52=NULL;

#define DECL(lib, pfx1, pfx2, sep, id) \
  if (NULL==(pfx1.id=(void *)GetProcAddress(hLib##lib, #pfx2 #sep #id))) \
    goto fail

int a52_stub_load(const char *path, char *p)
{
  strcpy(p, "in_ffsox\\liba52.dll");

  if (NULL==(hLibA52=LoadLibrary(TEXT(path))))
    goto fail;

  DECL(A52,a52,a52,_,block);
  DECL(A52,a52,a52,_,dynrng);
  DECL(A52,a52,a52,_,frame);
  DECL(A52,a52,a52,_,free);
  DECL(A52,a52,a52,_,init);
  DECL(A52,a52,a52,_,samples);
  DECL(A52,a52,a52,_,syncinfo);

  return a52_stub_valid=1;
fail:
  return a52_stub_unload();
}

#undef DECL

int a52_stub_unload()
{
  if (NULL!=hLibA52) {
    FreeLibrary(hLibA52);
    hLibA52=NULL;
  }

  return a52_stub_valid=0;
}
