/*
 * liba52_stub.h
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __LIBA52_STUB_H__
#define __LIBA52_STUB_H__

#include <a52dec/config.h>
#include <inttypes.h>
#include <a52dec/a52.h>

extern int a52_stub_valid;

extern struct a52_stub {
  typeof(a52_block) *block;
  typeof(a52_dynrng) *dynrng;
  typeof(a52_frame) *frame;
  typeof(a52_free) *free;
  typeof(a52_init) *init;
  typeof(a52_samples) *samples;
  typeof(a52_syncinfo) *syncinfo;
} a52;

#ifdef __DYNAMIC__
#define a52_block (*a52.block)
#define a52_dynrng (*a52.dynrng)
#define a52_frame (*a52.frame)
#define a52_free (*a52.free)
#define a52_init (*a52.init)
#define a52_samples (*a52.samples)
#define a52_syncinfo (*a52.syncinfo)
#endif

int a52_stub_load(const char *path, char *p);
int a52_stub_unload();

#endif // __LIBA52_STUB_H__
