/*
 * libsox_stub.c
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <windows.h>
#include "libsox_stub.h"

int sox_stub_valid=0;
struct sox_stub sox;
static HINSTANCE hLibSoX=NULL;

#define DECL(lib, pfx1, pfx2, sep, id) \
  if (NULL==(pfx1.id=(void *)GetProcAddress(hLib##lib, #pfx2 #sep #id))) \
    goto fail

int sox_stub_load(const char *path, char *p)
{
  strcpy(p, "in_ffsox\\libsox.dll");

  if (NULL==(hLibSoX=LoadLibrary(TEXT(path))))
    goto fail;

  DECL(SoX,sox,sox,_,add_effect);
  DECL(SoX,sox,sox,_,create_effect);
  DECL(SoX,sox,sox,_,create_effects_chain);
  DECL(SoX,sox,sox,_,delete_effects_chain);
  DECL(SoX,sox,sox,_,effect_options);
  DECL(SoX,sox,sox,_,find_comment);
  DECL(SoX,sox,sox,_,find_effect);
  DECL(SoX,sox,sox,_,flow_effects);
  DECL(SoX,sox,sox,_,format_quit);
  DECL(SoX,sox,sox,_,init);
  DECL(SoX,sox,sox,_,quit);
  DECL(SoX,sox,sox,_,read);
  DECL(SoX,sox,sox,_,close);
  DECL(SoX,sox,sox,_,open_read);
  DECL(SoX,sox,sox,_,num_comments);
  DECL(SoX,sox,sox,_,format_fns);

  return sox_stub_valid=1;
fail:
  return sox_stub_unload();
}

#undef DECL

int sox_stub_unload()
{
  if (NULL!=hLibSoX) {
    FreeLibrary(hLibSoX);
    hLibSoX=NULL;
  }

  return sox_stub_valid=0;
}
