/*
 * madutil.h
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
# ifndef __MADUTIL_H__
# define __MADUTIL_H__

#include <stdio.h>
//#include <mad.h>
#define __DYNAMIC__
#include "libmad_stub.h"
//#include <libavformat/avformat.h>

/*****************************************************************************/

typedef enum mad_sync_state {
  MAD_SYNC_STATE_UNDEFINED,
  MAD_SYNC_STATE_OUTER_LOOP,
  MAD_SYNC_STATE_INNER_LOOP,
  MAD_SYNC_STATE_FAIL,
  MAD_SYNC_STATE_DONE
} mad_sync_state_t;

typedef struct mad_sync {
  mad_sync_state_t state;
  struct mad_decoder *decoder;

  enum mad_flow (*error_func)(void *, struct mad_stream *, struct mad_frame *);
  void *error_data;
  int bad_last_frame;
  struct mad_stream *stream;
  struct mad_frame *frame;
  struct mad_synth *synth;
} mad_sync_t;

int mad_sync_init(mad_sync_t *sync, struct mad_decoder *decoder);
void mad_sync_finish(mad_sync_t *sync);
int mad_sync_next(mad_sync_t *sync);

/*****************************************************************************/

#define LIBMAD "libmad"

//extern AVCodec mp3_decoder;
//extern AVCodec libmad_adapter;

/*****************************************************************************/

#ifdef __XXX_
typedef struct ff_audio_dec ff_audio_dec_t;

typedef int (*ff_audio_dec_read)(ff_audio_dec_t *dec, AVPacket *p);
typedef void (*ff_audio_dec_write)(ff_audio_dec_t *dec, uint8_t *samples,
    int frame_size);

struct ff_audio_dec {
  AVCodecContext *aCodecCtx;

  ff_audio_dec_read read;
  void *input;

  ff_audio_dec_write write;
  void *output;

  int size;
  AVPacket p1;
  AVPacket p2;
};

void ff_audio_dec_open(ff_audio_dec_t *dec, AVCodecContext *aCodecCtx,
    ff_audio_dec_read read, void *input,
    ff_audio_dec_write write, void *output);
void ff_audio_dec_close(ff_audio_dec_t *dec);
int ff_audio_dec_next(ff_audio_dec_t *dec);
#endif // __XXX__

# endif // __MADUTIL_H__
