/*
 * setdlgitemurl_stub.c
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
// http://www.wischik.com/lu/programmer/setdlgitemurl.html
#include <windows.h>
#include "setdlgitemurl_stub.h"

int setdlgitemurl_stub_valid=0;
struct setdlgitemurl_stub setdlgitemurl;
static HINSTANCE hSetDlgItemUrl=NULL;

#define DECL(lib, pfx1, pfx2, sep, id) \
  if (NULL==(pfx1.id=(void *)GetProcAddress(h##lib, #pfx2 #sep #id))) \
    goto fail

int setdlgitemurl_stub_load(const char *path, char *p)
{
  strcpy(p, "in_ffsox\\setdlgitemurl.dll");

  if (NULL==(hSetDlgItemUrl=LoadLibrary(TEXT(path))))
    goto fail;

  DECL(SetDlgItemUrl,setdlgitemurl,,,SetDlgItemUrl);

  return setdlgitemurl_stub_valid=1;
fail:
  return setdlgitemurl_stub_unload();
}

#undef DECL

int setdlgitemurl_stub_unload()
{
  if (NULL!=hSetDlgItemUrl) {
    FreeLibrary(hSetDlgItemUrl);
    hSetDlgItemUrl=NULL;
  }

  return setdlgitemurl_stub_valid=0;
}
